package dmillerw.menu.gui.menu;

import dmillerw.menu.data.session.EditSessionData;
import dmillerw.menu.gui.GuiStack;
import dmillerw.menu.helper.GuiRenderHelper;
import dmillerw.menu.helper.ItemRenderHelper;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.GuiTextField;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.NonNullList;
import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;

import javax.annotation.Nonnull;
import java.io.IOException;

public class GuiPickIcon extends GuiScreen {
    private static final int MAX_COLUMN = 14;
    private static final int MAX_ROW = 4; // Actually increased by one
    private GuiTextField textSearch;
    private GuiButton buttonCancel;
    private NonNullList<ItemStack> stacks;
    private int listScrollIndex = 0;

    @Override
    public void func_73876_c() {
        this.textSearch.func_146178_a();
    }

    @Override
    public void func_73866_w_() {
        Keyboard.enableRepeatEvents(true);

        stacks = NonNullList.func_191196_a();

        for (Item item : Item.field_150901_e) {
            if (item != null && item.func_77640_w() != null) {
                item.func_150895_a(item.func_77640_w(), stacks);
            }
        }

        this.field_146292_n.clear();

        this.field_146292_n.add(this.buttonCancel = new GuiButton(0, this.field_146294_l / 2 - 75, this.field_146295_m - 60 + 12, 150, 20, I18n.func_135052_a("gui.cancel")));

        this.textSearch = new GuiTextField(0, this.field_146289_q, this.field_146294_l / 2 - 150, 40, 300, 20);
        this.textSearch.func_146203_f(32767);
        this.textSearch.func_146195_b(true);
    }

    @Override
    public void func_146281_b() {
        Keyboard.enableRepeatEvents(false);
    }

    @Override
    public boolean func_73868_f() {
        return false;
    }

    @Override
    protected void func_146284_a(GuiButton button) {
        if (button.field_146124_l) {
            if (button.field_146127_k == 0) {
                GuiStack.pop();
            }
        }
    }

    @Override
    protected void func_73869_a(char key, int keycode) {
        if (this.textSearch.func_146201_a(key, keycode)) {
            listScrollIndex = 0;

            if (!textSearch.func_146179_b().trim().isEmpty()) {
                stacks.clear();

                NonNullList<ItemStack> temp = NonNullList.func_191196_a();

                if (textSearch.func_146179_b().equalsIgnoreCase(".inv")) {
                    EntityPlayer player = Minecraft.func_71410_x().field_71439_g;
                    for (int i = 0; i < player.field_71071_by.func_70302_i_(); i++) {
                        ItemStack stack = player.field_71071_by.func_70301_a(i);
                        stacks.add(stack.func_77946_l());
                    }
                } else {
                    for (Item item : Item.field_150901_e) {
                        if (item != null && item.func_77640_w() != null) {
                            item.func_150895_a(item.func_77640_w(), temp);
                        }
                    }

                    for (ItemStack stack : temp) {
                        if (!stack.func_190926_b() && stack != null && stack.func_82833_r().toLowerCase().contains(textSearch.func_146179_b().toLowerCase())) {
                            stacks.add(stack);
                        }
                    }
                }
            } else {
                stacks.clear();

                for (Object anItemRegistry : Item.field_150901_e) {
                    Item item = (Item) anItemRegistry;

                    if (item != null && item.func_77640_w() != null) {
                        item.func_150895_a(item.func_77640_w(), stacks);
                    }
                }
            }
        }

        if (keycode != 28 && keycode != 156) {
            if (keycode == 1) {
                this.func_146284_a(this.buttonCancel);
            }
        }
    }

    @Override
    protected void func_73864_a(int mouseX, int mouseY, int button) throws IOException {
        super.func_73864_a(mouseX, mouseY, button);

        ItemStack clicked = getClickedStack(this.field_146294_l / 2, this.field_146295_m / 2 - 40, mouseX, mouseY);

        if (!clicked.func_190926_b()) {
            EditSessionData.icon = clicked;
            GuiStack.pop();
        }

        if (buttonCancel.func_146116_c(Minecraft.func_71410_x(), mouseX, mouseY)) {
            EditSessionData.icon = ItemStack.field_190927_a;
        }
    }

    @Override
    public void func_73863_a(int mouseX, int mouseY, float partial) {
        onWheelScrolled(Mouse.getDWheel());

        this.func_146276_q_();

        this.textSearch.func_146194_f();

        super.func_73863_a(mouseX, mouseY, partial);

        GuiRenderHelper.renderHeaderAndFooter(this, 25, 20, 5, "Select an Icon:");

        drawList(this.field_146294_l / 2, this.field_146295_m / 2 - 40, mouseX, mouseY);
    }

    private void onWheelScrolled(int wheel) {
        wheel = -wheel;

        if (wheel < 0) {
            listScrollIndex -= 2;
            if (listScrollIndex < 0) {
                listScrollIndex = 0;
            }
        }

        if (wheel > 0) {
            listScrollIndex += 2;
            if (listScrollIndex > Math.max(0, (stacks.size() / MAX_COLUMN)) - MAX_ROW) {
                listScrollIndex = Math.max(0, (stacks.size() / MAX_COLUMN) - MAX_ROW);
            }
        }
    }

    private void drawList(int x, int y, int mx, int my) {
        ItemStack highlighted = ItemStack.field_190927_a;
        float highlightedX = 0;
        float highlightedY = 0;

        for (int i = MAX_COLUMN * listScrollIndex; i < stacks.size(); i++) {
            int drawX = i % MAX_COLUMN;
            int drawY = i / MAX_COLUMN;

            if (((i - 14 * listScrollIndex) / MAX_COLUMN) <= MAX_ROW) {
                GlStateManager.func_179094_E();

                boolean scaled = false;
                float actualDrawX = (x + drawX * 20) - (7 * 20) + 10;
                float actualDrawY = (y + drawY * 20);
                actualDrawY -= 20 * listScrollIndex;

                if (mx > (actualDrawX - 8) && mx < (actualDrawX + 20 - 8) && my > actualDrawY - 8 && my < actualDrawY + 20 - 8) {
                    scaled = true;
                    highlighted = stacks.get(i);
                    highlightedX = actualDrawX / 2;
                    highlightedY = actualDrawY / 2;
                }

                if (!scaled) {
                    ItemRenderHelper.renderItem(actualDrawX, actualDrawY, stacks.get(i));
                }

                GlStateManager.func_179121_F();
            } else {
                break;
            }
        }

        if (!highlighted.func_190926_b()) {
            GlStateManager.func_179094_E();
            GlStateManager.func_179152_a(2, 2, 2);
            ItemRenderHelper.renderItem(highlightedX, highlightedY, highlighted);
            GlStateManager.func_179121_F();
        }
    }

    @Nonnull
    private ItemStack getClickedStack(int x, int y, int mx, int my) {
        for (int i = MAX_COLUMN * listScrollIndex; i < stacks.size(); i++) {
            int drawX = i % MAX_COLUMN;
            int drawY = i / MAX_COLUMN;

            if (((i - 14 * listScrollIndex) / MAX_COLUMN) <= MAX_ROW) {
                float actualDrawX = (x + drawX * 20) - (7 * 20) + 10;
                float actualDrawY = (y + drawY * 20);
                actualDrawY -= 20 * listScrollIndex;

                if (mx > (actualDrawX - 8) && mx < (actualDrawX + 20 - 8) && my > actualDrawY - 8 && my < actualDrawY + 20 - 8) {
                    return stacks.get(i);
                }
            }
        }
        return ItemStack.field_190927_a;
    }
}
