package dmillerw.menu.gui.menu;

import dmillerw.menu.gui.GuiStack;
import dmillerw.menu.helper.GuiRenderHelper;
import dmillerw.menu.helper.ItemRenderHelper;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.input.Keyboard;

public class GuiPickItem extends GuiScreen {
    private static final int XSIZE = 176;
    private static final int YSIZE = 166;
    private int guiLeft;
    private int guiTop;

    @Override
    public void func_73866_w_() {
        super.func_73866_w_();
        this.guiLeft = (this.field_146294_l - XSIZE) / 2;
        this.guiTop = (this.field_146295_m - YSIZE) / 2;
    }

    @Override
    public void func_73863_a(int par1, int par2, float par3) {
        this.func_146276_q_();
        super.func_73863_a(par1, par2, par3);
        GuiRenderHelper.renderHeaderAndFooter(this, 25, 20, 5, "Pick an Item:");
        this.field_146297_k.func_110434_K().func_110577_a(new ResourceLocation("textures/gui/container/inventory.png"));
        func_73729_b(guiLeft, guiTop, 0, 0, XSIZE, YSIZE);

        Slot mousedOver = null;

        // Draw inventory contents
        GlStateManager.func_179094_E();
        for (int i1 = 0; i1 < this.field_146297_k.field_71439_g.field_71069_bz.field_75151_b.size(); ++i1) {
            Slot slot = this.field_146297_k.field_71439_g.field_71069_bz.field_75151_b.get(i1);
            if (par1 - guiLeft >= slot.field_75223_e && par1 - guiLeft <= slot.field_75223_e + 16 && par2 - guiTop >= slot.field_75221_f && par2 - guiTop <= slot.field_75221_f + 16) {
                mousedOver = slot;
            } else {
                this.drawSlot(slot, false);
            }
        }
        if (mousedOver != null && !mousedOver.func_75211_c().func_190926_b()) {
            GlStateManager.func_179094_E();
            drawSlot(mousedOver, true);
            GlStateManager.func_179121_F();
            func_146285_a(mousedOver.func_75211_c(), par1, par2);
        }
        GlStateManager.func_179121_F();
    }

    private void drawSlot(Slot slot, boolean scale) {
        int i = slot.field_75223_e;
        int j = slot.field_75221_f;
        ItemStack stack = slot.func_75211_c();

        this.field_73735_i = 100.0F;
        field_146296_j.field_77023_b = 100.0F;

        if (stack.func_190926_b()) {
            TextureAtlasSprite sprite = slot.getBackgroundSprite();

            if (sprite != null) {
                GlStateManager.func_179140_f();
                this.field_146297_k.func_110434_K().func_110577_a(TextureMap.field_110575_b);
                this.func_175175_a(this.guiLeft + i, this.guiTop + j, sprite, 16, 16);
                GlStateManager.func_179145_e();
            }
        }

        if (!stack.func_190926_b()) {
            if (scale) {
                GlStateManager.func_179152_a(2, 2, 2);
                ItemRenderHelper.renderItem((this.guiLeft + i + 8) / 2, (this.guiTop + j + 8) / 2, stack);
            } else {
                ItemRenderHelper.renderItem(this.guiLeft + i + 8, this.guiTop + j + 8, stack);
            }
        }

        field_146296_j.field_77023_b = 0.0F;
        this.field_73735_i = 0.0F;
    }

    @Override
    protected void func_73864_a(int mouseX, int mouseY, int button) {
        if (button == 0) {
            for (int i1 = 0; i1 < this.field_146297_k.field_71439_g.field_71069_bz.field_75151_b.size(); ++i1) {
                Slot slot = this.field_146297_k.field_71439_g.field_71069_bz.field_75151_b.get(i1);
                if (mouseX - guiLeft >= slot.field_75223_e && mouseX - guiLeft <= slot.field_75223_e + 16 && mouseY - guiTop >= slot.field_75221_f && mouseY - guiTop <= slot.field_75221_f + 16) {
                    ItemStack stack = slot.func_75211_c();
                    if (!stack.func_190926_b()) {
                        GuiClickAction.item = stack.func_77946_l();
                        GuiStack.pop();
                    }
                }
            }
        }
    }

    @Override
    public void func_146281_b() {
        Keyboard.enableRepeatEvents(false);
    }

    @Override
    public boolean func_73868_f() {
        return false;
    }

    @Override
    protected void func_73869_a(char key, int keycode) {
        if (keycode == 1) {
            GuiStack.pop();
        }
    }

    @Override
    protected void func_146284_a(GuiButton button) {
        if (button.field_146124_l) {
            if (button.field_146127_k == 0) {
                GuiStack.pop();
            }
        }
    }
}
