package dmillerw.menu.network.packet.server;

import dmillerw.menu.helper.HeldHelper;
import dmillerw.menu.network.packet.Packet;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemStack;
import net.minecraft.network.PacketBuffer;
import net.minecraft.util.ActionResult;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumHand;

public class PacketUseItem extends Packet<PacketUseItem> {
    private int slot;

    public PacketUseItem() {
    }

    public PacketUseItem(int slot) {
        this.slot = slot;
    }

    @Override
    protected void handleClientSide(EntityPlayer player) {
    }

    @Override
    protected void handleServerSide(EntityPlayerMP player) {
        ItemStack slotStack = player.field_71071_by.func_70301_a(this.slot);
        ItemStack heldSaved = player.func_184614_ca();
        EnumHand hand = EnumHand.MAIN_HAND;
        EntityEquipmentSlot slot = HeldHelper.getSlotFromHand(hand);

        player.func_184201_a(slot, slotStack);
        ItemStack heldItem = player.func_184586_b(hand);
        ActionResult<ItemStack> useStack = heldItem.func_77957_a(player.field_70170_p, player, hand);
        if (useStack.func_188397_a() == EnumActionResult.SUCCESS) {
            player.field_71071_by.field_70462_a.set(this.slot, useStack.func_188398_b());
        }
        player.func_184201_a(slot, heldSaved);

        player.func_71120_a(player.field_71069_bz);
    }

    @Override
    public void toBytes(PacketBuffer buffer) {
        buffer.writeInt(slot);
    }

    @Override
    public void fromBytes(PacketBuffer buffer) {
        slot = buffer.readInt();
    }
}
